import numpy as np

def proyecta( P, K, R, vc ) :
	# Modelo de la cámara obscura
	# l p = KR( I | -vc ) P

	p = np.zeros( (3,8) )
	vv = np.zeros( (3,1) )

	i = 0
	while i<8 :
		vv[:,0] = P[:,i] + vc[:,0]
		p[:,i] = (K @ ( R @ vv ))[:,0]
		# Homogenizando
		p[0,i] /= p[2,i]
		p[1,i] /= p[2,i]
		p[2,i] = 1.0
		i += 1

	return p

def dibuja( p ) :
	# 1 2 3 4
	# 5 6 7 8
	print( p[0,0], p[1,0] ) 
	print( p[0,1], p[1,1] ) 
	print( p[0,2], p[1,2] ) 
	print( p[0,3], p[1,3] ) 
	print( p[0,0], p[1,0] ) 

	print( )

	print( p[0,4], p[1,4] ) 
	print( p[0,5], p[1,5] ) 
	print( p[0,6], p[1,6] ) 
	print( p[0,7], p[1,7] ) 
	print( p[0,4], p[1,4] ) 

	print( )

	print( p[0,0], p[1,0] ) 
	print( p[0,4], p[1,4] ) 

	print( )

	print( p[0,1], p[1,1] ) 
	print( p[0,5], p[1,5] ) 

	print( )
	
	print( p[0,2], p[1,2] ) 
	print( p[0,6], p[1,6] ) 

	print( )
	
	print( p[0,3], p[1,3] ) 
	print( p[0,7], p[1,7] ) 

def hace_cubo( lx, ly, lz ) :
	P = np.zeros( (3,8) )

	P[0,0] = 0.0  
	P[1,0] = 0.0
	P[2,0] = lz

	P[0,1] = lx
	P[1,1] = 0.0
	P[2,1] = lz 

	P[0,2] = lx
	P[1,2] = 0.0
	P[2,2] = 0.0

	P[0,3] = 0.0
	P[1,3] = 0.0
	P[2,3] = 0.0

	P[0,4] = 0.0  
	P[1,4] = ly
	P[2,4] = lz

	P[0,5] = lx
	P[1,5] = ly
	P[2,5] = lz 

	P[0,6] = lx
	P[1,6] = ly
	P[2,6] = 0.0

	P[0,7] = 0.0
	P[1,7] = ly
	P[2,7] = 0.0

	return P
